untyped
global function cl_spreadvisualizer_init
global function ui_spreadvisualizer_init
const float ADJUST_SPREAD = 0.01

void function cl_spreadvisualizer_init()
{
	#if CLIENT
	if ( !IsLobby() )
		thread spreaddisplay_main()
	#endif
}

#if CLIENT
void function spreaddisplay_main()
{
	var circle = RuiCreate( $"ui/crosshair_lstar.rpak", clGlobal.topoFullScreen, RUI_DRAW_HUD, 1 ) // lstar, plus
	float spread = 0.0
	float adsfrac = 0.0
	RuiSetFloat( circle, "adjustedSpread", 0.0 )
	RuiSetFloat( circle, "adsFrac", 0.0 )
	
	do
	{
		WaitFrame()
		
		RuiSetFloat3( circle, "teamColor", GetConVarFloat3( "mm_spreaddisplay_color" ) )
		
		if ( IsValid( GetLocalClientPlayer() ) && IsValid( GetLocalClientPlayer().GetActiveWeapon() ) )
		{
			spread = GetLocalClientPlayer().GetAttackSpreadAngle()
		}
		
		adsfrac = 0
		if ( spread < 1.5 )
		{
			adsfrac = (1.0 - pow(( spread / 1.5 ),1.1)) // fade out when it gets too small basically
		}
		if ( !GetConVarBool( "mm_spreaddisplay_enabled" ) ) // if disabled, fade it fully out using adsfrac
			adsfrac = 1
		
		float fov_scale_factor = 1 / (GetConVarFloat( "cl_fovScale" ) / 1.55) // calibrated for 110 fov which is 1.55 fovScale
		RuiSetFloat( circle, "adjustedSpread", spread * ADJUST_SPREAD * fov_scale_factor )
		RuiSetFloat( circle, "adsFrac", adsfrac )
		
	} while ( IsValid( GetLocalClientPlayer() ) )
	
	RuiDestroyIfAlive( circle )
}

vector function GetConVarFloat3(string convar){
    array<string> value = split(GetConVarString(convar), " ")
    try{
        return Vector(value[0].tofloat(), value[1].tofloat(), value[2].tofloat()) 
    }
    catch(ex){
        throw "Invalid convar " + convar + "! make sure it is a float3 and formatted as \"X Y Z\""
    }
    unreachable
}
#endif

void function ui_spreadvisualizer_init()
{
	#if UI
    ModSettings_AddModTitle		( "mm.SpreadVisualizer" )
    ModSettings_AddModCategory	( "Spread Visualizer" )
    ModSettings_AddSetting		( "mm_spreaddisplay_color",   "Color",   "vector" )
    ModSettings_AddEnumSetting	( "mm_spreaddisplay_enabled", "Enabled", ["Off", "On"] )
	#endif
}